<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::timing::test::TimerTest Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing.html">timing</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test.html">test</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html">TimerTest</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::timing::test::TimerTest Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Test harness for <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html">Timer</a> class.  
 <a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#details">More...</a></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::utils::timing::test::TimerTest:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test_inherit__map">
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::avsCommon::utils::timing::test::TimerTest:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test_coll__map" id="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test_coll__map">
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa3d4b6a3a18fed56b26bd46bd84f7472"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#aa3d4b6a3a18fed56b26bd46bd84f7472">SetUp</a> () override</td></tr>
<tr class="memdesc:aa3d4b6a3a18fed56b26bd46bd84f7472"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set up the test harness for running a test.  <a href="#aa3d4b6a3a18fed56b26bd46bd84f7472">More...</a><br /></td></tr>
<tr class="separator:aa3d4b6a3a18fed56b26bd46bd84f7472"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c606508728ed280d6dc4f3d2c3ffa97"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#a9c606508728ed280d6dc4f3d2c3ffa97">simpleTask</a> (std::chrono::milliseconds duration)</td></tr>
<tr class="separator:a9c606508728ed280d6dc4f3d2c3ffa97"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a8947bd42cb4bf8da16ff07842c1fdd56"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#a8947bd42cb4bf8da16ff07842c1fdd56">verifyTimestamps</a> (std::chrono::time_point&lt; std::chrono::steady_clock &gt; startTime, std::chrono::milliseconds delay, std::chrono::milliseconds period, <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html#a3abfcab70fb00bbe0fb6137c8e15b77b">Timer::PeriodType</a> periodType, std::chrono::milliseconds duration, size_t iterations=1)</td></tr>
<tr class="separator:a8947bd42cb4bf8da16ff07842c1fdd56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a04239c746be9f4a32c449f18faf1d412"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#a04239c746be9f4a32c449f18faf1d412">waitForInactive</a> ()</td></tr>
<tr class="separator:a04239c746be9f4a32c449f18faf1d412"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a1f9390695da3abe89ee7954dd8faa09d"><td class="memItemLeft" align="right" valign="top">std::mutex&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#a1f9390695da3abe89ee7954dd8faa09d">m_mutex</a></td></tr>
<tr class="memdesc:a1f9390695da3abe89ee7954dd8faa09d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mutex which protects access to <code>m_timestamps</code>.  <a href="#a1f9390695da3abe89ee7954dd8faa09d">More...</a><br /></td></tr>
<tr class="separator:a1f9390695da3abe89ee7954dd8faa09d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0bdee505a45650f44fb8b3a214ebaaef"><td class="memItemLeft" align="right" valign="top">std::condition_variable&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#a0bdee505a45650f44fb8b3a214ebaaef">m_conditionVariable</a></td></tr>
<tr class="memdesc:a0bdee505a45650f44fb8b3a214ebaaef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Condition variable to notify about changes to <code>m_timestamps</code>.  <a href="#a0bdee505a45650f44fb8b3a214ebaaef">More...</a><br /></td></tr>
<tr class="separator:a0bdee505a45650f44fb8b3a214ebaaef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab37e9627d7c99514a559d6ccff01865"><td class="memItemLeft" align="right" valign="top">std::deque&lt; std::chrono::time_point&lt; std::chrono::steady_clock &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#aab37e9627d7c99514a559d6ccff01865">m_timestamps</a></td></tr>
<tr class="memdesc:aab37e9627d7c99514a559d6ccff01865"><td class="mdescLeft">&#160;</td><td class="mdescRight">This deque accumulates timestamps from timer calls to <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#a9c606508728ed280d6dc4f3d2c3ffa97">simpleTask()</a>.  <a href="#aab37e9627d7c99514a559d6ccff01865">More...</a><br /></td></tr>
<tr class="separator:aab37e9627d7c99514a559d6ccff01865"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8921517b1cccc05a4186fee01b6eaf77"><td class="memItemLeft" align="right" valign="top">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html">Timer</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#a8921517b1cccc05a4186fee01b6eaf77">m_timer</a></td></tr>
<tr class="memdesc:a8921517b1cccc05a4186fee01b6eaf77"><td class="mdescLeft">&#160;</td><td class="mdescRight">The timer to use in the tests.  <a href="#a8921517b1cccc05a4186fee01b6eaf77">More...</a><br /></td></tr>
<tr class="separator:a8921517b1cccc05a4186fee01b6eaf77"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Test harness for <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html">Timer</a> class. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="aa3d4b6a3a18fed56b26bd46bd84f7472"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa3d4b6a3a18fed56b26bd46bd84f7472">&#9670;&nbsp;</a></span>SetUp()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::timing::test::TimerTest::SetUp </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set up the test harness for running a test. </p>

</div>
</div>
<a id="a9c606508728ed280d6dc4f3d2c3ffa97"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9c606508728ed280d6dc4f3d2c3ffa97">&#9670;&nbsp;</a></span>simpleTask()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::timing::test::TimerTest::simpleTask </td>
          <td>(</td>
          <td class="paramtype">std::chrono::milliseconds&#160;</td>
          <td class="paramname"><em>duration</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">A simple task to test <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html">Timer</a> instances with. This task records its start time in <code>m_timestamps</code> and then waits for the specified duration before returning.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">duration</td><td>The number of milliseconds to sleep before returning. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8947bd42cb4bf8da16ff07842c1fdd56"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8947bd42cb4bf8da16ff07842c1fdd56">&#9670;&nbsp;</a></span>verifyTimestamps()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::timing::test::TimerTest::verifyTimestamps </td>
          <td>(</td>
          <td class="paramtype">std::chrono::time_point&lt; std::chrono::steady_clock &gt;&#160;</td>
          <td class="paramname"><em>startTime</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::milliseconds&#160;</td>
          <td class="paramname"><em>delay</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::milliseconds&#160;</td>
          <td class="paramname"><em>period</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html#a3abfcab70fb00bbe0fb6137c8e15b77b">Timer::PeriodType</a>&#160;</td>
          <td class="paramname"><em>periodType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::milliseconds&#160;</td>
          <td class="paramname"><em>duration</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>iterations</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Utility function which verifies the size and values of <code>m_timestamps</code> after runnning a timer.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">startTime</td><td>The start time for a timer, against which <code>m_timestamps</code> should be verified. </td></tr>
    <tr><td class="paramname">period</td><td>The period of the timer. </td></tr>
    <tr><td class="paramname">periodType</td><td>The type of period used for the timer. </td></tr>
    <tr><td class="paramname">duration</td><td>The runtime duration of the timer task. </td></tr>
    <tr><td class="paramname">iterations</td><td>The expected number of task calls made by the timer. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a04239c746be9f4a32c449f18faf1d412"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a04239c746be9f4a32c449f18faf1d412">&#9670;&nbsp;</a></span>waitForInactive()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::timing::test::TimerTest::waitForInactive </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Utility function which polls for a timer to go inactive. This function will time out and fail if the timer does not go inactive within SHORT_DELAY.</p>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if timer is inactive, else <code>false</code>. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a0bdee505a45650f44fb8b3a214ebaaef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0bdee505a45650f44fb8b3a214ebaaef">&#9670;&nbsp;</a></span>m_conditionVariable</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::condition_variable alexaClientSDK::avsCommon::utils::timing::test::TimerTest::m_conditionVariable</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Condition variable to notify about changes to <code>m_timestamps</code>. </p>

</div>
</div>
<a id="a1f9390695da3abe89ee7954dd8faa09d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1f9390695da3abe89ee7954dd8faa09d">&#9670;&nbsp;</a></span>m_mutex</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::mutex alexaClientSDK::avsCommon::utils::timing::test::TimerTest::m_mutex</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Mutex which protects access to <code>m_timestamps</code>. </p>

</div>
</div>
<a id="a8921517b1cccc05a4186fee01b6eaf77"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8921517b1cccc05a4186fee01b6eaf77">&#9670;&nbsp;</a></span>m_timer</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1_timer.html">Timer</a>&gt; alexaClientSDK::avsCommon::utils::timing::test::TimerTest::m_timer</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The timer to use in the tests. </p>

</div>
</div>
<a id="aab37e9627d7c99514a559d6ccff01865"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aab37e9627d7c99514a559d6ccff01865">&#9670;&nbsp;</a></span>m_timestamps</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::deque&lt;std::chrono::time_point&lt;std::chrono::steady_clock&gt; &gt; alexaClientSDK::avsCommon::utils::timing::test::TimerTest::m_timestamps</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>This deque accumulates timestamps from timer calls to <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1timing_1_1test_1_1_timer_test.html#a9c606508728ed280d6dc4f3d2c3ffa97">simpleTask()</a>. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/test/<a class="el" href="_timer_test_8cpp.html">TimerTest.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
